#ifndef CONTENEUR_H
#define CONTENEUR_H

using namespace std ;

#include <iostream>
#include <cmath>

#include <qpainter.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qfiledialog.h>
#include <qmessagebox.h>
#include <qstring.h>

#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
//#include <qslider.h>
#include <qcombobox.h>
#include <qscrollview.h>


class planche ;

class conteneur : public QWidget
{
    Q_OBJECT

 public :
    conteneur();
    ~conteneur();
    void getRepartitionLong(long* ,long,long) ;
    void getRepartitionDouble(long* ,double,double) ;
    void changeCoordinate(QString*) ;
    void changeParametersWithoutXY(QString*) ;
    void changeSizeMatrix(long) ;
    void loadPalette(QString) ;
    void saveImage(QString) ;

 signals :
    void signalFrameChanged( double,double,double,double ) ;
    void signalRepartitionIntChanged(long*,long,long) ;

 private slots :
    void slotCalculate(QString*) ;
    void slotDrawMatrixLong(long,long,long,int,bool) ;
    void slotDelayChanged(int) ;
    void slotFrameChanged( double,double,double,double ) ;
    void slotRepartitionIntChanged( long*,long,long ) ;

 protected :
    virtual void resizeEvent(QResizeEvent* ) ;

 private :

    QScrollView* _scrollview ;
    planche* _planche ;
};

#endif

