#ifndef FENETREPRINCIPALE_H
#define FENETREPRINCIPALE_H


#include <qmainwindow.h>

#include "constants.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QAction;
class QActionGroup;
class QToolBar;
class QPopupMenu;
class QTabWidget;
class QWidget;
class QLineEdit;
class QPushButton;
class QTextEdit;
class QButtonGroup;
class QCheckBox;
class QRadioButton;
class QLabel;
class QFrame;
class QSlider ;
class QColor ;

class conteneur ;
class repartition ;
class QDoubleSlider ;

class fenetrePrincipale : public QMainWindow
{
	Q_OBJECT   //  fenetrePrincipale cre des slots !!!

 public :
  fenetrePrincipale() ;  // constructeur
  ~fenetrePrincipale() ;  // dstructeur

 signals :
  void signalCalculate(QString*) ;
  void signalDrawMatrixLong(long,long,long,int,bool) ;
  void signalDrawMatrixDouble(double,double,long,int,bool) ;
  void signalAffichageChanged(int) ; // obsolte

 protected :
 virtual void paintEvent( QPaintEvent* event ) ;
 virtual void resizeEvent( QResizeEvent* event) ;

 private slots :
  void slotCoordinateChanged() ;
  void slotParamatersWithoutXYChanged() ;
  void slotCalculate() ;
  void slotPreferences() ;
  void slotDrawMatrixForRepartition(int,int) ;
  void slotDrawMatrixForPalette(int,int) ;
  void slotDrawRepartitionInt(long*,long,long) ;
  void slotDrawRepartitionZoomed(int,int) ;
  void slotLoadMatrix() ;
  void slotSaveImage() ;
  //void slotPaletteChanged(unsigned int* ,int ) ;
  void slotSizeChanged(int) ;
  void slotLoadPalette() ;
  void slotFrameChanged( double,double,double,double) ;
  void slotAbout() ;
  void slotAboutQt() ;
  void slotNeRienFaire() ;

 private :
    long whatischeckedForColor() ;
    void getCoordinate(QString*) ;
    void getParametersWithoutXY(QString*) ;

    QTabWidget* tabWidget2;
    repartition* _repartition;
    QLineEdit* lineEdit3;  // min
    QLineEdit* lineEdit4;  // max
    QPushButton* pushButton1;
    //QTextEdit* textEdit1;
    QButtonGroup* buttonGroup2;
    QRadioButton* RadioButton4;
    QRadioButton* RadioButton2;
    QRadioButton* RadioButton3;
    QCheckBox* checkBox5;
    QWidget* tab_2;
    QLabel* textLabel3;
    QLineEdit* lineEdit5;
    QLineEdit* lineEdit6;
    QLineEdit* lineEdit7;
    QLineEdit* lineEdit8;
    QLabel* textLabel4;
    QLabel* textLabel5;
    QLabel* textLabel6;
    QFrame* frame5;
    QLabel* textLabel1;
    QSlider* slider1;
    /////   widgets pour les paramtres des fractales
    QLabel* textLabel_P1 ;
    QLineEdit* lineEdit_P1 ;


  // menu
  QMenuBar* _menubar ;
  QPopupMenu* _filemenu ;
  QPopupMenu* _typemenu ;
  QPopupMenu* _sizemenu ;
  QPopupMenu* _operationmenu ;
  QPopupMenu* _helpmenu ;
  QStatusBar* _statusbar ;
  QLabel* _labelType ;
  QDoubleSlider* _dsRepartition ;
  QDoubleSlider* _dsPalette ;
  conteneur* _conteneur ;
  long repartitionZoom[SIZE_IMAGE_REPARTITION_X] ;
  double minid, maxid ;
  long minii, maxii,whatSthat ;
  QString* _parameters ;


  bool isMatrixLong ;
  bool drawMatrixWithRepartition ;



} ;

#endif



