#ifndef PLANCHE_H
#define PLANCHE_H

using namespace std ;
#include <iostream>
#include <cmath>

#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qstring.h>

#include "constants.h"


class setIntMath ;
class setDoubleMath ;
class setMandelbrot ;

class planche : public QWidget
{
   Q_OBJECT

 public :
  planche( QWidget*,const char*,WFlags ) ;  // constructeur
  ~planche() ;
  void setPaletteRGB( unsigned long*,long) ;
  void setFrame(double,double,double,double) ;
  void calculate() ;
  void calculateF9(QString*) ;
  void drawMatrixLong(long,long,long,int,bool) ;
  void drawMatrixDouble(double,double,long,int,bool) ;
  void drawMatrixLongOnlyDelay(int) ;
  void calculateMiniMaxi() ;
  void calculateMindMaxd() ;
  void calculateRepartitionInt(long*,long,long) ;
  void calculateRepartitionDouble(long*,double,double) ;
  void changeCoordinate(QString*) ;
  void changeParametersWithoutXY(QString* ) ;
  void changeSizeMatrix(long) ;
  void loadPalette(QString f) ;
  void saveImage(QString f) ;

 signals :
  void signalFrameChanged(double,double,double,double) ;
  void signalRepartitionIntChanged(long*,long,long) ;
  void signalRepartitionDoubleChanged(long*,long,long) ;

 protected :
  virtual void mouseDoubleClickEvent( QMouseEvent* ) ;
  virtual void mousePressEvent( QMouseEvent* ) ;
  virtual void mouseReleaseEvent( QMouseEvent* ) ;
  virtual void mouseMoveEvent( QMouseEvent* ) ;
  virtual void paintEvent( QPaintEvent* ) ;
  //virtual void resizeEvent( QResizeEvent* ) ;

 private :
   void drawMatrix() ;

 private :
  QPixmap _buffer ;
  double xMin,xMax,yMin,yMax,dx,dy,xMinNew,xMaxNew,yMinNew,yMaxNew,mind,maxd,mindReal,maxdReal ;
  long repartitionGlobal[SIZE_IMAGE_REPARTITION_X] ;
  unsigned long* paletteRGB ;
  long nbColors,sizeX,mini,maxi,miniReal,maxiReal,typeFA,delay ;
  long* matrixLong ;
  double* matrixDouble ;
  setMandelbrot* _mandelbrot ;
  bool isInversed ;

  // gestion de la slection
  QPoint oldPoint , newPoint , mvtPoint ;
  bool frameCreated , overallMvt ;
  long typeButtonPressed ;
  long frameChanged ;
} ;

#endif
