
#include <qdoubleslider.h>


QDoubleSlider :: QDoubleSlider( QWidget* parent,const char* name,WFlags f ) : QWidget(parent,name,f)
{
 minVal = 0 ;
 maxVal = 100 ;
 val1 = 0 ;
 val2 = 0 ;
 startVal1 = 0 ;
 startVal2 = 0 ;

 setMinimumSize(22,22 ) ;
 _triangleVal1 = new QPointArray(3) ;
 _triangleVal2 = new QPointArray(3) ;
 _triangleVal1->setPoint(0,10,2) ;
 _triangleVal1->setPoint(1,10,20) ;
 _triangleVal1->setPoint(2,2,20) ;
 _triangleVal2->setPoint(0,10,2) ;
 _triangleVal2->setPoint(1,10,20) ;
 _triangleVal2->setPoint(2,18,20) ;
 cursorIntriangle1 = false ;
 cursorIntriangle2 = false ;
}

QDoubleSlider :: QDoubleSlider( int minv, int maxv, int v1, int v2, QWidget* parent,const char* name,WFlags f ) : QWidget(parent,name,f)
{

 minVal = minv ;
 maxVal = maxv ;

 val1 = v1 ;
 val2 = v2 ;
 startVal1 = v1 ;
 startVal2 = v2 ;

 setMinimumSize(22,22 ) ;

 _triangleVal1 = new QPointArray(3) ;
 _triangleVal2 = new QPointArray(3) ;
 cursorIntriangle1 = false ;
 cursorIntriangle2 = false ;

 repaint() ;
 }

QDoubleSlider :: ~QDoubleSlider()
{
 delete  _triangleVal1 ;
 delete  _triangleVal2 ;
}

int QDoubleSlider :: minValue() const { return minVal ; }
int QDoubleSlider :: maxValue() const { return maxVal ; }
void QDoubleSlider :: setMinValue( int v ) { minVal = v ; }
void QDoubleSlider :: setMaxValue( int v ) { maxVal = v ; }
int QDoubleSlider :: value1() { return val1 ; }
int QDoubleSlider :: value2() { return val2 ; }
void QDoubleSlider :: values( int* v1,int* v2) { *v1 = val1 ; *v2 = val2 ; }

void QDoubleSlider :: setValue1( int v ) { val1 = v ; repaint() ; }
void QDoubleSlider :: setValue2( int v ) { val2 = v ; repaint() ; }
void QDoubleSlider :: setValues( int v1,int v2) { val1 = v1 ; val2 = v2 ; repaint() ; }

void QDoubleSlider :: mousePressEvent( QMouseEvent* e )
{
 int xi,xs,yi,ys,x,y ;

 x = e->x() ;
 y = e->y() ;
 _triangleVal1->point(0,&xs,&yi) ;
 _triangleVal1->point(2,&xi,&ys) ;
 if ((x<=xs) && (x>=xi))
	{
	  if ((y<=ys) && (y>=yi))
		{
		 if ((xs-x)*(ys-yi) <= (xs-xi)*(y-yi))
			{
			 cursorIntriangle1 = true ;
			 _lastPos = x ;
			}
		 	else cursorIntriangle1 = false ;
		}
	}
 _triangleVal2->point(0,&xi,&yi) ;
 _triangleVal2->point(2,&xs,&ys) ;
 if ((x<=xs) && (x>=xi))
	{
	  if ((y<=ys) && (y>=yi))
		{
		 if ((x-xi)*(ys-yi) <= (xs-xi)*(y-yi))
			{
			 cursorIntriangle2 = true ;
			 cursorIntriangle1 = false ;
			 _lastPos = x ;
			}
		 	else
			{
			 cursorIntriangle2 = false ;
			 cursorIntriangle1 = false ;
			}
		}
	}

 //cout << " cursorIntriangle1 = " << cursorIntriangle1 << endl ;
 //cout << " cursorIntriangle2 = " << cursorIntriangle2 << endl ;
}

void QDoubleSlider :: mouseMoveEvent( QMouseEvent* e)
{
 int lastPos1, lastPos2,temp,dx ;

 _triangleVal1->point(0,&lastPos1,&temp) ;
 _triangleVal2->point(0,&lastPos2,&temp) ;

 if (cursorIntriangle1)
	{
	 dx= e->x() - _lastPos ;
	 lastPos1 += dx ;
	 if ((lastPos1 <= lastPos2) && (lastPos1>=10))
		{
		 _triangleVal1->translate(dx,0) ;
		 _lastPos += dx ;
		 _triangleVal1->point(0,&lastPos1,&temp) ;
		 _triangleVal2->point(0,&lastPos2,&temp) ;
		 val1 = minVal + ((maxVal-minVal) * (lastPos1-10))/(width()-20) ;
		 repaint() ;
		 emit valuesChanged(val1,val2 ) ;
		 //cout << " val1 = " << val1 << " : val2 = " << val2 << endl ;
		}
	}

 if (cursorIntriangle2)
	{
	 dx= e->x() - _lastPos ;
	 lastPos2 += dx ;
	 if ((lastPos1 <= lastPos2) && (lastPos2<=width()-10))
		{
		 _triangleVal2->translate(dx,0) ;
		 _lastPos += dx ;
		 _triangleVal2->point(0,&lastPos2,&temp) ;
		 val2 = minVal +((maxVal-minVal)*(lastPos2-10))/(width()-20) ;
		 repaint() ;
		 emit valuesChanged(val1,val2 ) ;
		 //cout << " val1 = " << val1 << " : val2 = " << val2 << endl ;
		}
	}
}

void QDoubleSlider :: mouseReleaseEvent( QMouseEvent* e )
{
 cursorIntriangle1 = false ;
 cursorIntriangle2 = false ;
}

void QDoubleSlider :: paintEvent( QPaintEvent* )
{
 QPainter painter ;
 int  w,pos ;

 w = width() ;

 painter.begin( this) ;
 painter.drawLine(10,2,width()-10,2) ;
 if (minVal != maxVal) pos = 10 + (val1-minVal)*(w-20)/(maxVal-minVal) ; else pos = 10 ;
 _triangleVal1->setPoint(0,pos,2) ;
 _triangleVal1->setPoint(1,pos,20) ;
 _triangleVal1->setPoint(2,pos-8,20) ;
 if (minVal != maxVal) pos = 10 + (val2-minVal)*(w-20)/(maxVal-minVal) ; else pos = 10 ;
 _triangleVal2->setPoint(0,pos,2) ;
 _triangleVal2->setPoint(1,pos,20) ;
 _triangleVal2->setPoint(2,pos+8,20) ;
 painter.drawConvexPolygon( *_triangleVal1,0,3 ) ;
 painter.drawConvexPolygon( *_triangleVal2,0,3 ) ;
 painter.end() ;
}

void QDoubleSlider :: resizeEvent( QResizeEvent* )
{
}




