#include "setJulia.h"

setJulia :: setJulia()
{
 iterations = 150 ;
 cx = 0.0 ;
 cy = 0.0 ;
}

setJulia :: ~setJulia()
{
}

void setJulia :: setParameters(QString* p)
{
 bool ok ;

 iterations = p[4].toLong(&ok) ;
 if (not(ok)) iterations = 150 ;
 cx = p[5].toDouble(&ok) ;
 if (not(ok)) cx = 0.0 ;
 cy = p[6].toDouble(&ok) ;
 if (not(ok)) cy = 0.0 ;
}


void setJulia :: streamParameters( QTextStream& st )
{
 QString nb ;

 st << "[Type]" << endl ;
 st << "Julia" << endl ;
 st << "[Parameter] [Nb iterations,Cx,Cy]" << endl ;
 st << nb.setNum( iterations ) << endl ;
 st << nb.setNum( cx,'g',16) << endl ;
 st << nb.setNum( cy,'g',16) << endl ;
}

void setJulia :: calculate( long* m,double xInf,double ySup,double dx,double dy,long size )
{
 long k,i,j ;
 double yAux, a0 , a1 , x0 , y0 , a2 ;


 for(i = 0 ; i < size ; i++)
	{
	 yAux = ySup-i*dy ;
	 for( j=0 ; j < size ; j++ )
	 	{
		 x0 = xInf+j*dx ;
		 y0 = yAux ;
		 for( k = 0 ; k < iterations ; k++ )
 			{
			 a0 = x0*x0 ;
			 a1 = y0*y0 ;
			 if ( a0 + a1 >= 4.0 ) break ;
			 a2 = a0 - a1 + cx ;
			 y0 = 2.0*x0*y0+cy ;
			 x0 = a2 ;
			}
		 m[i*size+j] = k ;
		}
	}
}




