#include "setIntMath.h"
#include "setMandelbrot.h"

setMandelbrot :: setMandelbrot()
{
 iterations = 150 ;
}

setMandelbrot :: ~setMandelbrot()
{
}

void setMandelbrot :: setParameters(QString* p)
{
 bool ok ;

 iterations = p[4].toLong(&ok) ;
 if (not(ok)) iterations = 150 ;
}

void setMandelbrot :: streamParameters( QTextStream& st )
{
 QString nb ;

 st << "[Type]" << endl ;
 st << "Mandelbrot" << endl ;
 st << "[Parameter] [Nb iterations]" << endl ;
 st << nb.setNum( iterations ) << endl ;
}

void setMandelbrot :: calculate( long* m,double xInf,double ySup,double dx,double dy,long size )
{
 long k,i,j ;
 double cx , cy , a0 , a1 , x0 , y0 , a2 ;


 for(i = 0 ; i < size ; i++)
	{
	 cy = ySup-i*dy ;
	 for( j=0 ; j < size ; j++ )
	 	{
		 cx = xInf+j*dx ;
		 x0 = cx ;
		 y0 = cy ;
		 for( k = 0 ; k < iterations ; k++ )
 			{
			 a0 = x0*x0 ;
			 a1 = y0*y0 ;
			 if ( a0 + a1 >= 4.0 ) break ;
			 a2 = a0 - a1 + cx ;
			 y0 = 2.0*x0*y0+cy ;
			 x0 = a2 ;
			}
		 m[i*size+j] = k ;
		}
	}
}




